package sexpression;

import static recursion.tail.TailCalls.done;
import static recursion.tail.TailCalls.tailCall;

import recursion.tail.TailCall;

@DisplayName("list")
public class Cons extends SExpression {

    private SExpression first;
    private SExpression rest;

    public Cons(SExpression first, SExpression rest) {
        this.first = first;
        this.rest = rest;
    }

    public SExpression getFirst() {
        return first;
    }

    public SExpression getRest() {
        return rest;
    }

    public void setFirst(SExpression first) {
        this.first = first;
    }

    public void setRest(SExpression rest) {
        this.rest = rest;
    }

    @Override
    public boolean isCons() {
        return true;
    }

    @Override
    public String toString() {
        return toStringTailRecursive("(").invoke();
    }

    private TailCall<String> toStringTailRecursive(String precedingString) {
        String leadingString = precedingString + first.toString();

        if (rest.isNull())
            return done(leadingString + ")");
        else if (rest.isCons())
            return tailCall(() -> ((Cons) rest).toStringTailRecursive(leadingString + " "));

        return done(leadingString + " . " + rest.toString() + ")");
    }

}
